#This Plesk mk-file. Need for using portupgrade for update and install standart packages 
#from ports. Packages may be installed from various repositories (defined in portupgrade's
# config file.
#Target may be redefined in Makefile of port. Definiton some targets must to be before 
#include this file.
#For example:
#
# Makefile:
# ---------
#
#  # New ports collection makefile for:    psa
#  # Date created:                         2006-04-19
#  # Whom:                                 SW-Soft
#  #
#  # $FreeBSD: $
#  #
#
#  PORTNAME= psa
#  PORTVERSION= 8.1.0
#  PORTREVISION=
#  CATEGORIES= www
#  MASTER_SITES= ftp://rubtsov.plesk.ru/incoming/packages/
#
#  MAINTAINER= admins@swsoft.com
#  COMMENT= Plesk (C) SWsoft Inc. 2006
#
#  EXTRACT_SUFX= .sh
#  DISTNAME= psa_v8.1.0_build81060419.13_os_FreeBSD_6.0_i386
#
#  RUN_DEPENDS+=   gettext:${PORTSDIR}/devel/gettext
#  RUN_DEPENDS+=   unzip:${PORTSDIR}/archivers/unzip
#
#  do-install:
#         @sh ${DISTDIR}/${DISTNAME}${EXTRACT_SUFX}
#
#  .include <plesk.install.mk>
#
#-----------------------------------------------------------------------------------------
#
#Suported OPTIONS
#
#NO_CONFIGURE = yes               Skip configure target
#
#NO_BUILD = yes                   Block with build targets was skipped.
#
#NO_INSTALL = yes                 Block with install targets was skipped
#
#NO_SCRIPTS = yes                 Installation scripts was skipped
#
#NO_CHECKSUM =                    Do not check the MD5 sum for archive.
#
#NO_EXTRACT = yes                 Install ports without archive. 
#
#VERBOSE = yes                    Print extended infomatiion in execution 
#                                 time of install/deinstll scripts
#
#
#
#
#

.if !defined(_PREMKINCLUDED)
.include <bsd.port.pre.mk>
.endif

#-----------------------------------------------------------------------------------------
# Variables
#-----------------------------------------------------------------------------------------
OWN_SITE=http://www.swsoft.com
PORTUPGRADE?=/usr/local/sbin/portupgrade
PORTUPGRADE_PORT?=${PORTSDIR}/sysutils/portupgrade
VALID_CATEGORIES+= swsoft
PACKAGE_INSTALLDIR?= ${LOCALBASE}
PKG_DB_DIR?= /var/db/pkg

.if !defined(FETCHDIR)
FETCHDIR= ${DISTDIR}
.endif

.if defined(VERBOSE) || defined(PLESK_INSTALLER_DEBUG)
VERBOSE_FLAG=1
.else
VERBOSE_FLAG=
.endif


SED_ENV+= \
	-e 's|%D|${PACKAGE_INSTALLDIR}|g' \
	-e 's|^\@exec \(.*\)|\"\1\"|g'

#-----------------------------------------------------------------------------------------
#Fetch
#-----------------------------------------------------------------------------------------
.if !defined(NO_CHECKSUM) && !defined(NO_EXTRACT)
pre-fetch: fetch-now
	@file=`${MD5} ${DISTDIR}/${DISTFILES} | ${AWK} -F '=' '{print $$2}'` && \
	sum=`${CAT} ${MD5_FILE} | ${GREP} ${DISTFILES} | ${AWK} -F '=' '{print $$2}'` && \
	if [ "X$$sum" != "X$$file" ]; then \
		${ECHO} "${DISTFILES} was to be refetch"; \
		${RM} -f ${DISTDIR}/${DISTFILES}; \
	fi
.else
pre-fetch: fetch-now 
	@${MKDIR} ${.CURDIR}/work
.endif

.if !target(fetch-now)
fetch-now:
.   if defined(FETCH_SITES_LIST) && defined(FETCH_FILES_LIST) 
.      for _list in ${FETCH_SITES_LIST}
.        for _files in ${FETCH_FILES_LIST}
.	     if !exists(${FETCHDIR}/${_files})
		@cd ${FETCHDIR} && /usr/bin/fetch -FR ${_list}/${_files} || continue
.            endif
.        endfor
.      endfor
.   endif
.endif

#-----------------------------------------------------------------------------------------
#Extract
#-----------------------------------------------------------------------------------------
.if defined(NO_UPGRADE_DEPENDS)
pre-extract: do-index 
.else
pre-extract: do-index conflicts pre-portupgrade do-portupgrade
.endif

#------------------------------------------------------------------------------------------
# Resolve Conflicts
#------------------------------------------------------------------------------------------

#Check conflicts with packages into system
.if defined(NO_CONFLICTS)
conflicts:
.else
conflicts:
	@conflicts=`${MAKE} -V CONFLICTS | xargs echo -n`; \
	${MAKE} CONFLICTS_PSA="$$conflicts" COUNT=1 do-conflicts
.endif

do-conflicts:
	@for list in ${CONFLICTS_PSA}; do \
		db_path=`find ${PKG_DBDIR}/$$list -type d 2>/dev/null` || true; \
		for path in $$db_path; do \
			full_name=`basename $$path`; \
			origin=`cat "${PKG_DBDIR}/$$full_name/+CONTENTS" | grep '@comment ORIGIN'|awk -F ':' '{print $$2}'`; \
			if [ ! -d ${PORTSDIR}/$$origin ]; then \
				pkg_delete -f $$full_name; \
			else \
				coincide=`cd ${PORTSDIR}/$$origin && make -V PKGNAME | grep $$list`; \
				if [ "X$$coincide" != "X" ]; then \
					pkg_delete -f $$full_name; \
				else \
					portupgrade -P $$origin >/dev/null || pkg_delete -f $$full_name; \
				fi; \
			fi; \
		done; \
	done

#------------------------------------------------------------------------------------------
# Resolve Depends
#------------------------------------------------------------------------------------------

#Check portupgrade
pre-portupgrade:
	@pkg_info 2>&1 | grep portupgrade >/dev/null 2>&1; \
	if [ $$? -ne 0 ]; then \
	   echo "==> Portupgrade not found. Installing..."; \
	   cd ${PORTUPGRADE_PORT} && make install clean; \
	fi

#Recursive requirements
#part 1
do-portupgrade:
	@depends=`${MAKE} -V RUN_DEPENDS -V LIB_DEPENDS | xargs echo -n`; \
	${MAKE} DEPENDS_PSA="$$depends" COUNT=1 do-portupgrade1

#part 2
do-portupgrade1:
	@for i in `${ECHO} -n ${DEPENDS_PSA}`; do \
		cut_depend=`${ECHO} $$i |sed -e 's|\(.*:${PORTSDIR}/\)\(.*\)|\2|g'`; \
		pkgname=`cd ${PORTSDIR}/$$cut_depend && ${MAKE} -V PKGNAME`; \
		if [ ! `ls ${PKG_DB_DIR}| grep $$pkgname` ]; then \
			depends=`cd ${PORTSDIR}/$$cut_depend && ${MAKE} -V RUN_DEPENDS -V LIB_DEPENDS| xargs echo -n`; \
			count=`expr ${COUNT} + 1` && \
			${MAKE} DEPENDS_PSA="$$depends" COUNT=$$count do-portupgrade1 || exit 1; \
			if [ "X$$count" = "X10" ]; then \
				echo "Deep of recursion very big. Exit"; \
				exit 1; \
			fi; \
			${PORTUPGRADE} -N -P -Ww $$cut_depend || \
			make do-error; \
		else \
			${PORTUPGRADE} -P -r $$cut_depend; \
		fi; \
	done;

.if !target(do-extract) && defined(NO_EXTRACT)
do-extract:
	@${MKDIR} ${WRKSRC}
.endif

#-----------------------------------------------------------------------------------------
#Configure 
#-----------------------------------------------------------------------------------------

.if defined(NO_CONFIGURE)
configure: extract
.endif

#-----------------------------------------------------------------------------------------
#Build targets block
#-----------------------------------------------------------------------------------------
.if !defined(NO_BUILD)

.if !target(build)
build: configure pre-build 
	@${TOUCH} ${TOUCH_FLAGS} ${BUILD_COOKIE}
.endif

.if !target(do-build)
do-build:
.endif

.endif #NO_BUILD

#-----------------------------------------------------------------------------------------
#Install targets block
#-----------------------------------------------------------------------------------------
.if !defined(NO_INSTALL)

pre-install:

.if !target(do-install)
do-install: do-install-pre do-install-now do-exec do-install-post
 
do-install-pre:
. if !defined(NO_SCRIPTS)
	@PLESK_INSTALLER_DEBUG=${VERBOSE_FLAG} \
		${SH} ${PKGINSTALL} ${PKGNAME} PRE-INSTALL
. endif

.if !target(do-install-now)
do-install-now:
. if !defined(NO_EXTRACT) && !defined(NO_INSTALL)
	@echo -n "==> Copying files into installation directory... "
	@${CP} -RPf ${WRKSRC}/* ${PACKAGE_INSTALLDIR}/	
	@echo "done"
.endif
.endif

do-install-post:
. if !defined(NO_SCRIPTS)
	@PLESK_INSTALLER_DEBUG=${VERBOSE_FLAG} \
		${SH} ${PKGINSTALL} ${PKGNAME} POST-INSTALL
. endif
.endif

.endif

reinstall: deinstall install

#-------------------------------------------------------------------------------------------
# Upgrade targets block
#-------------------------------------------------------------------------------------------
.if !target(upgrade)
upgrade: pre-upgrade do-upgrade post-upgrade

.if !target(pre-upgrade)
pre-upgrade:
.endif

.if !target(do-upgrade)
do-upgrade:
.endif

.if !target(post-upgrade)
post-upgrade:
.endif
.endif

#-------------------------------------------------------------------------------------------
# Set correct permissions 
#-------------------------------------------------------------------------------------------
EXEC_LIST!= cat ${.CURDIR}/pkg-plist | grep '@exec ' | sed ${SED_ENV}

.if !target(do-exec)
do-exec:
	@for CMD in ${EXEC_LIST}; do \
		${SH} -c "$$CMD"; \
	done
.endif

#-------------------------------------------------------------------------------------------
# Error processing
#-------------------------------------------------------------------------------------------
do-error:
		@echo "Unable to install some components"
		@exit 1

#-------------------------------------------------------------------------------------------
# End
#-------------------------------------------------------------------------------------------

pre-index: 
	@${CP} -f ${INDEXDIR}/${INDEXFILE} ${INDEXDIR}/${INDEXFILE}.bkp
	
do-index: 
	@if ${MAKE} describe >/dev/null; then \
		if ! ${GREP} "^${PKGNAME}" ${INDEXDIR}/${INDEXFILE} > /dev/null; then \
			${MAKE} describe >> ${INDEXDIR}/${INDEXFILE}; \
		fi; \
	else \
.               error "Inconsistent port"; \
	fi 

index: do-index

.include <bsd.port.post.mk>

.if defined(USE_PHP)
.include "${PORTSDIR}/Mk/bsd.php.mk"
.endif

